#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double dnorm(float x, float mu, float sigma);
double pnorm(float x, float mu, float sigma);

//--------------------------------------------------
int main(int argc, char *argv[]) {
  float x, mu, sigma;
  
  if (argc < 4) {
    puts("Devi dare x, mu e sigma");
    return(0);
  }

  x     = atof(argv[1]);
  mu    = atof(argv[2]);
  sigma = atof(argv[3]);
  
  if (sigma <= 0) {
    puts("sigma deve essere positivo");
    return(0);
  }

   printf("x=%f, mu=%f, sigma=%.3f\n", x, mu, sigma);
   printf("f(x) = %.3e\n", dnorm(x, mu, sigma));
   printf("F(x) = %.3e\n", pnorm(x, mu, sigma));
   
  return(0);
}


double dnorm(float x, float mu, float sigma){
  double f;

  f = 1./(sqrt(2*M_PI) * sigma) * exp(-pow(x-mu,2.)/(2.*sigma*sigma));
  return(f);  
}
  

double pnorm(float x, float mu, float sigma){
  double z, F;

  z=(x-mu)/sigma;
  F = 0.5 + 0.5*erf(z/sqrt(2.));
  return(F);  
}
 
