#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double dnorm(float x, float mu, float sigma);
double pnorm(float x, float mu, float sigma);

//--------------------------------------------------
int main(int argc, char *argv[]) {
  float x, mu, sigma;
  FILE *fp;

  fp = fopen("parametri_gaussiana.txt", "r");

  while ( fscanf(fp, "%f %f %f\n", &x, &mu, &sigma) == 3) {
    printf("x=%f, mu=%f, sigma=%.3f\n", x, mu, sigma);
    printf("f(x) = %.3e\n", dnorm(x, mu, sigma));
    printf("F(x) = %.3e\n", pnorm(x, mu, sigma));
  }

  fclose(fp);
  return(0);
}


double dnorm(float x, float mu, float sigma){
  double f;

  f = 1./(sqrt(2*M_PI) * sigma) * exp(-pow(x-mu,2.)/(2.*sigma*sigma));
  return(f);  
}
  

double pnorm(float x, float mu, float sigma){
  double z, F;

  z=(x-mu)/sigma;
  F = 0.5 + 0.5*erf(z/sqrt(2.));
  return(F);  
}
 
