#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define NMAX 1000000

void setRandomSeed( unsigned RandomSeed);
void rnorm12(int n, float mu, float sigma, float x[]);

//--------------------------------------------------
int main(int argc, char *argv[]) {
  int n, i;
  float mu, sigma;
  float x[NMAX] = {0.};
  float sum=0., sum2=0., media, std;
  int EntroUnaSigma = 0;
  
  if (argc < 4) {
    puts("Devi dare n, mu e sigma");
    return(0);
  }

  n     = atoi(argv[1]);
  mu    = atof(argv[2]);
  sigma = atof(argv[3]);

  if (n < 1 || n > NMAX) {
    printf("n deve essere almeno 1 e non maggiore di %d\n", NMAX);
    return(0);
  } 
  if (sigma <= 0) {
    puts("sigma deve essere positivo");
    return(0);
  }

  
  //setRandomSeed(123456789); // mettere nr di matricola
  setRandomSeed(0);
  printf("n=%d, mu=%f, sigma=%.3f\n", n, mu, sigma);

  rnorm12(n, mu, sigma, x); 

  for(i=0; i<n; i++) {
    // printf(" %d, %f\n", i, x[i] );
    sum  += x[i];
    sum2 += x[i]*x[i];
    if (x[i] >= (mu - sigma) && x[i] <= (mu + sigma))
      EntroUnaSigma++;
  }
  media  = sum / (float) n;
  std = sqrt( sum2 / (float) n - media*media ); 
  
  printf("media = %f; std = %f\n", media, std);
  printf("Numero di valori entro una sigma da mu: %d\n", EntroUnaSigma);
  
  return(0);
}

//---------------------------------------------------
void setRandomSeed( unsigned RandomSeed) {

  // se RandomSeed==0  usa il tempo del computer
  // altrimenti usa il numero passato come argomento
  // Nota: RICHIEDE gli header stdlib.h e time.h

  time_t t;

  if (RandomSeed == 0 ) {     // se == 0 si usa il tempo
     RandomSeed = (unsigned) time(&t);
  }

  printf("seed %u\n", RandomSeed );
  srand( RandomSeed );
}

//------------------------------------------------------
void rnorm12(int n, float mu, float sigma, float x[]) {
  float r, s;
  int i, j;
  for (i=0; i<n; i++) {
    for (j=0, s=-6.; j<12; j++){
       s += (float) rand() / (float) RAND_MAX;
    }
    x[i] = s * sigma + mu;
  }
}
